/****************************************************************************

USB-CAN-Interface Communication Center
Anzeige von Gerteinformationen

(c) 2020 Dipl.-Ing. (FH) Rainer Reusch, Reusch Elektronik

RADStudio XE7

Erstellt: 2020-03-12
Letzte nderung: 2020-03-12

*****************************************************************************/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UnitDeviceInformation.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormDeviceInfo *FormDeviceInfo;

//---------------------------------------------------------------------------
__fastcall TFormDeviceInfo::TFormDeviceInfo(TComponent* Owner)
	: TForm(Owner)
//---------------------------------------------------------------------------
{
	//
}

//---------------------------------------------------------------------------
void __fastcall TFormDeviceInfo::FormCreate(TObject *Sender)
//---------------------------------------------------------------------------
{
	ClientWidth = (BitBtnClose->Left<<1)+BitBtnClose->Width;
	ClientHeight = BitBtnClose->Top+BitBtnClose->Height+BitBtnClose->Left;
	StringGrid1->ColWidths[0] = StringGrid1->ClientWidth>>1;
	StringGrid1->ColWidths[1] = StringGrid1->ClientWidth-StringGrid1->ColWidths[0]-StringGrid1->ColCount;
	StringGrid1->Cells[0][0] = "Serial No.";
	StringGrid1->Cells[0][1] = "Revision";
	StringGrid1->Cells[0][2] = "Firmware";
	TGridRect r = {-1,-1,-1,-1};
	StringGrid1->Selection = r;
}

//---------------------------------------------------------------------------
void __fastcall TFormDeviceInfo::Execute(TPoint WinPos, TDevComm *ADevComm)
//---------------------------------------------------------------------------
{
	const UnicodeString na = "(not available)";
	Left = WinPos.x;
	Top = WinPos.y;
	StringGrid1->Cells[1][0] = na;
	StringGrid1->Cells[1][1] = na;
	StringGrid1->Cells[1][2] = na;
	Memo1->Clear();
	if (ADevComm) {
		if (ADevComm->DeviceInfo.cmd==USB_INFO) {
			UnicodeString s = ADevComm->DeviceInfo.SerialNo;
			StringGrid1->Cells[1][0] = s;
			switch (ADevComm->DeviceInfo.Revision) {
			case 0 : StringGrid1->Cells[1][1] = "1.0";
				break;
			case 1 : StringGrid1->Cells[1][1] = "(unknown)";
				break;
			case 2 : StringGrid1->Cells[1][1] = "(unknown)";
				break;
			case 3 : StringGrid1->Cells[1][1] = "(unknown)";
				break;
			default:
				StringGrid1->Cells[1][1] = "(unknown)";
			}
			StringGrid1->Cells[1][2] = "V"+IntToHex(ADevComm->DeviceInfo.Version>>8,1)+"."+IntToHex(ADevComm->DeviceInfo.Version&0xFF,2);
			Memo1->Text = ADevComm->DeviceInfo.SerialNo;  // Seriennr. in Memo
		}
	}
	ShowModal();
}

//---------------------------------------------------------------------------
void __fastcall TFormDeviceInfo::StringGrid1MouseDown(TObject *Sender, TMouseButton Button,
					TShiftState Shift, int X, int Y)
//---------------------------------------------------------------------------
// Bettigung der rechten Maustaste -> Seriennr. in die Zwischenablage
{
	if (Memo1->Text.Length()) {
		Memo1->SelectAll();
		Memo1->CopyToClipboard();
		MessageBeep(0);
	}
}
//---------------------------------------------------------------------------

