/****************************************************************************

USB-CAN-Interface Communication Center
Dialog: Filtereinstellungen

(c) 2019-2020 Reusch Elektronik, Dipl.-Ing. (FH) Rainer Reusch

Created: 2020-03-14
Changed: 2020-03-14

*****************************************************************************/

//---------------------------------------------------------------------------

#ifndef UnitFilterH
#define UnitFilterH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.Buttons.hpp>
#include <Vcl.ComCtrls.hpp>
#include <Vcl.ExtCtrls.hpp>
#include "uci_common.h"
#include "UnitEditMsg.h"
//---------------------------------------------------------------------------

typedef TCANFilter TCANFilters[14];  // Definition der vom Gert untersttzten 14 Filterbnke

class TFormFilter : public TForm
{
__published:	// Von der IDE verwaltete Komponenten
	TBitBtn *BitBtnDefault;
	TBitBtn *BitBtnOk;
	TBitBtn *BitBtnCancel;
	TTabControl *TabControl1;
	TCheckBox *CheckBoxActive;
	TComboBox *ComboBoxIDType;
	TComboBox *ComboBoxMode;
	TLabeledEdit *LabeledEdit1;
	TLabeledEdit *LabeledEdit2;
	TLabel *Label1;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall BitBtnDefaultClick(TObject *Sender);
	void __fastcall TabControl1Change(TObject *Sender);
private:	// Benutzer-Deklarationen
	TCANFilters CANFilters;
	int LastIndex;
	void __fastcall FilterToDlg(void);
	void __fastcall DlgToFilter(void);
public:		// Benutzer-Deklarationen
	__fastcall TFormFilter(TComponent* Owner);
	bool __fastcall Execute(TPoint WinPos, TCANFilters *ACANFilters);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormFilter *FormFilter;
//---------------------------------------------------------------------------
#endif
