/****************************************************************************

Demo for the USB/CAN Interface device

RADStudio XE7

(c) 2020 Reusch Elektronik

Created: 2020-03-27
Changed: 2020-03-28

****************************************************************************/

//---------------------------------------------------------------------------

#ifndef UnitMainH
#define UnitMainH
//---------------------------------------------------------------------------

#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include "uci_common.h"
#include "uci_if.h"

//---------------------------------------------------------------------------

class TFormMain : public TForm
{
__published:	// Von der IDE verwaltete Komponenten
	TLabel *Label1;
	TComboBox *ComboBoxDevices;
	TButton *ButtonOpen;
	TButton *ButtonClose;
	TMemo *Memo1;
	TButton *ButtonTx;
	TButton *ButtonRx;
	TLabel *Label2;
	TComboBox *ComboBoxSpeed;
	TCheckBox *CheckBoxTermination;
	TLabel *Label3;
	TButton *ButtonConfig;
	TLabel *Label4;
	TButton *ButtonFilterMask;
	TButton *ButtonFilterList;
	TButton *ButtonFilterAll;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall ButtonOpenClick(TObject *Sender);
	void __fastcall ButtonCloseClick(TObject *Sender);
	void __fastcall ButtonTxClick(TObject *Sender);
	void __fastcall ButtonConfigClick(TObject *Sender);
	void __fastcall ButtonRxClick(TObject *Sender);
	void __fastcall ButtonFilterMaskClick(TObject *Sender);
	void __fastcall ButtonFilterListClick(TObject *Sender);
	void __fastcall ButtonFilterAllClick(TObject *Sender);
private:	// Benutzer-Deklarationen
	TUCI *uci;	// interface class to the USB/CAN Interface device
	void __fastcall MsgToMemo(TCANData *CANData);
	MESSAGE void __fastcall WMDeviceChange(TMessage &Message);
protected:
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_DEVICECHANGE, TMessage, WMDeviceChange);
	END_MESSAGE_MAP(TForm)
public:		// Benutzer-Deklarationen
	__fastcall TFormMain(TComponent* Owner);
};

//---------------------------------------------------------------------------
extern PACKAGE TFormMain *FormMain;
//---------------------------------------------------------------------------

#endif
